#include <stdio.h>
#include <stdlib.h>

#include "headers/transformation.h"

struct image do_nothing(struct image const source) {
    struct image img;
    img.height = source.height;
    img.width = source.width;
    img.data = malloc(img.width * img.height * sizeof(struct pixel));

    for (size_t i = 0; i < source.height; i++) {
        for (size_t j = 0; j < source.width; j++) {
            img.data[i * img.width + j] = source.data[i * source.width + j];
        }
    }

    return img;
}

struct image rotate_90_right(struct image const source) {
    struct image img;
    img.height = source.width;
    img.width = source.height;
    img.data = malloc(img.width * img.height * sizeof(struct pixel));

    for (size_t i = 0; i < source.height; i++) {
        for (size_t j = 0; j < source.width; j++) {
            img.data[(img.height - 1 - j) * img.width + i] = source.data[i * source.width + j];
        }
    }

    return img;
}


struct image rotate_90_left(struct image const source){
    struct image img;
    img.height = source.width;
    img.width = source.height;
    img.data = malloc(img.width * img.height * sizeof(struct pixel));

    for (size_t i = 0; i < source.height; i++) {
        for (size_t j = 0; j < source.width; j++) {
            img.data[j * img.width + (img.width - 1 - i)] = source.data[i * source.width + j];
        }
    }

    return img;
}

struct image swap_horizontal(struct image const source) {
    struct image img;
    img.height = source.height;
    img.width = source.width;
    img.data = malloc(img.width * img.height * sizeof(struct pixel));

    for (size_t i = 0; i < source.height; i++) {
        for (size_t j = 0; j < source.width; j++) {
            img.data[i * img.width + j] = source.data[(source.height - 1 - i) * source.width + j];
        }
    }

    return img;
}


struct image swap_vertical(struct image const source){
    struct image img;
    img.height = source.height;
    img.width = source.width;
    img.data = malloc(img.width * img.height * sizeof(struct pixel));

    for (size_t i = 0; i < source.height; i++) {
        for (size_t j = 0; j < source.width; j++) {
            img.data[i * img.width + j] = source.data[i * source.width + (source.width - 1 - j)];
        }
    }

    return img;
}
